
		$(function(){

		    // get a reference to the canvas and context
		    var canvas=document.getElementById("canvas");
		    var ctx=canvas.getContext("2d");

		    // vars for current width and height of a canvas rectangle
     		var rwidth=1920;
			var rheight=1080;
		    var width=128;
		    var height=128;
		    var columns=8;
		    var rows=5;
		    var xStart=0;
		    var yStart=0;
		    var cWidth = width * columns;
		    var cHeight = height * rows;
		    var borderW = 1;
				var borderR=1;
		    var color1="#ff8c00";
		    var color2="#ff4800";
		    var textcolor="#efebe6";
		    var datacolor="#FFFFFF";
			var bordercolor ="#bb00ff";
//			var rastercolor ="#000000";
			var dataStartColor ="#5cb85c";
			var alphabet = "a b c d e f g h i j k l m n o p q r s t u v w x y z aa bb cc dd ee ff gg hh ii jj kk ll mm nn oo pp qq rr ss tt uu vv ww xx yy zz".split(" ");
			var upArr = '\u21E1';
			var downArr = '\u21E3';
			var leftArr = '\u21E0';
			var rightArr = '\u21E2';
			var stopSign = '\u26d4';
			var oddOrEven = "odd";
			var colOddEven = "odd";
		  var tileCount = 0;
		  var dataFlow = 1;
			var drawCoords = true;
			var drawData = true;
			var drawInfo = true;
			var drawBorder = true;
			var drawRBorder = true;

		    // references to the input-text elements
		    // used to let user change the rect width & height
				var $rwidth=document.getElementById('rwidth');
				var $rheight=document.getElementById('rheight');
		    var $width=document.getElementById('width');
		    var $height=document.getElementById('height');
		    var $rows=document.getElementById('rows');
		    var $columns=document.getElementById('columns');
		    var $borderW=document.getElementById('borderW');
				var $borderR=document.getElementById('borderR');
				var $color1=document.getElementById('color1');
				var $color2=document.getElementById('color2');
				var $textcolor=document.getElementById('textcolor');
				var $datacolor=document.getElementById('datacolor');
				var $bordercolor=document.getElementById('bordercolor');
	//		var $rastercolor=document.getElementById('rastercolor');


			var $radio1=document.getElementById('radio1');
			var $radio2=document.getElementById('radio2');
			var $radio3=document.getElementById('radio3');
			var $radio4=document.getElementById('radio4');
			var $radio5=document.getElementById('radio5');
			var $radio6=document.getElementById('radio6');
			var $radio7=document.getElementById('radio7');
			var $radio8=document.getElementById('radio8');
			var $drawcoords=document.getElementById('draw_coords_check');
			var $drawdata=document.getElementById('draw_data_check');
			var $drawinfo=document.getElementById('draw_info_check');
			var $drawborder=document.getElementById('draw_border_check');
			var $drawrborder=document.getElementById('draw_rborder_check');

		    // set the initial input-text values to the width/height vars
				//$rwidth.value=rwidth;
		    //$rheight.value=rheight;
		    $width.value=width;
		    $height.value=height;
		    $rows.value=rows;
		    $columns.value=columns;
		    $borderW.value=borderW;
		 	$borderR.value=borderR;
			$color1.value=color1;
			$color2.value=color2;
			$textcolor.value=textcolor;
			$datacolor.value=datacolor;
			$bordercolor.value=bordercolor;
//	$rastercolor.value=rastercolor;


		    // call the draw command
		    draw();

		    // listen for keyup events on width & height input-text elements
		    // Get the current values from input-text & set the width/height vars
		    // call draw to redraw the rect with the current width/height values
			$rwidth.addEventListener("keyup", function(){
					rwidth=this.value; //.value converts input field int to string***
					createArray();
					draw();
			}, false);

			$rheight.addEventListener("keyup", function(){
					rheight=this.value; //.value converts input field int to string***
					createArray();
					draw();
				}, false);

			  $width.addEventListener("keyup", function(){
		        width=this.value; //.value converts input field int to string***
		        createArray();
		        draw();
		    }, false);

		    $height.addEventListener("keyup", function(){
		        height=this.value; //.value converts input field int to string***
		        createArray();
		        draw();
		    }, false);

			 $rows.addEventListener("keyup", function(){
		        rows=this.value; //.value converts input field int to string***
		        createArray();
		        draw();
		    }, false);

		     $columns.addEventListener("keyup", function(){
		        columns=this.value; //.value converts input field int to string***
		        createArray();
		        draw();
		    }, false);

		    $borderW.addEventListener("keyup", function(){
		        borderW=this.value; //.value converts input field int to string***
		        createArray();
		        draw();
		    }, false);

				$borderR.addEventListener("keyup", function(){
						borderR=this.value; //.value converts input field int to string***
						createArray();
						draw();
			}, false);

		     $color1.addEventListener("input", function(){
		        color1=this.value; //.value converts input field int to string***
		        createArray();
		        draw();
		    }, false);

		     $color2.addEventListener("input", function(){
		        color2=this.value; //.value converts input field int to string***
		        createArray();
		        draw();
		    }, false);

		     $textcolor.addEventListener("input", function(){
		        textcolor=this.value; //.value converts input field int to string***
		        createArray();
		        draw();
		    }, false);

		     $datacolor.addEventListener("input", function(){
		        datacolor=this.value; //.value converts input field int to string***
		        createArray();
		        draw();
		    }, false);

		     $bordercolor.addEventListener("input", function(){
		        bordercolor=this.value; //.value converts input field int to string***
		        createArray();
		        draw();
		    }, false);
				//$rastercolor.addEventListener("input", function(){
					// rastercolor=this.value; //.value converts input field int to string***
					 //createArray();
					 //draw();
		//	 }, false);


		     $radio1.addEventListener("click", function(){
		        dataFlow=this.value; //.value converts input field int to string***
		        createArray();
		        draw();
		    }, false);

		     $radio2.addEventListener("click", function(){
		        dataFlow=this.value; //.value converts input field int to string***
		        createArray();
		        draw();
		    }, false);

		     $radio3.addEventListener("click", function(){
		        dataFlow=this.value; //.value converts input field int to string***
		        createArray();
		        draw();
		    }, false);

		     $radio4.addEventListener("click", function(){
		        dataFlow=this.value; //.value converts input field int to string***
		        createArray();
		        draw();
		    }, false);

		     $radio5.addEventListener("click", function(){
		        dataFlow=this.value; //.value converts input field int to string***
		        createArray();
		        draw();
		    }, false);

		     $radio6.addEventListener("click", function(){
		        dataFlow=this.value; //.value converts input field int to string***
		        createArray();
		        draw();
		    }, false);

		     $radio7.addEventListener("click", function(){
		        dataFlow=this.value; //.value converts input field int to string***
		        createArray();
		        draw();
		    }, false);

		     $radio8.addEventListener("click", function(){
		        dataFlow=this.value; //.value converts input field int to string***
		        createArray();
		        draw();
		    }, false);

		     $drawcoords.addEventListener("change", function(){
		        drawCoords = !drawCoords; //flips boolean of drawCoords t/f
		        createArray();
		        draw();
		    }, false);

		     $drawdata.addEventListener("change", function(){
		        drawData = !drawData; //flips boolean of drawData t/f
		        createArray();
		        draw();
		    }, false);

		    $drawinfo.addEventListener("change", function(){
		        drawInfo = !drawInfo; //flips boolean of drawInfo t/f
		        createArray();
		        draw();
		    }, false);

			$drawborder.addEventListener("change", function(){
		        drawBorder = !drawBorder; //flips boolean of drawBordert/f
		        createArray();
		        draw();
		    }, false);

				$drawrborder.addEventListener("change", function(){
							drawRBorder = !drawRBorder; //flips boolean of drawBordert/f
							createArray();
							draw();
					}, false);

		    // draw() clears the canvas and redraws the rect
		    // based on user input
		    function draw(){
		  ctx.canvas.width = rwidth;
		  ctx.canvas.height = rheight;
		  ctx.clearRect(0,0,canvas.width,canvas.height);
		  xStart=0; //reset x coord to 0 (default)
		  yStart=0; //reset y coord to 0 (default)

		  //check if row is even or odd
		  for (var j = 0; j < rows; j++){ //for every row
					for (var i = 0; i < columns; i++) { //for every column
						if ((i % 2) !=1){
							colOddEven = "odd";
						} else {
							colOddEven = "even";
						}
						if ((j % 2) !=1){ //for every other row
							 //start alternating patter with color option 1
							 oddOrEven = "odd";
							 if ((i % 2) != 1) {ctx.fillStyle=color1;
							 } else {ctx.fillStyle=color2;
							 } //end if/else
						 } else {
						 	oddOrEven = "even";
						 	 //start alternating patter with color option 2
							 if ((i % 2) != 1) {ctx.fillStyle=color2;
							 } else {ctx.fillStyle=color1;
							 } //end if/else
						 } //end if/else

						ctx.fillRect(xStart,yStart,width,height); //draw single tile
						console.log("Tile Drawn : ",alphabet[i],+j+1);

						//draw alphanumeric coordinates
						if (drawCoords){ //check drawCoords checkbox. no check = no coords
							ctx.fillStyle=textcolor;
							if (+width < 35 || +height < 35){ //tile size check
								ctx.font = "8px Helvetica";
								ctx.fillText(alphabet[i].toUpperCase() + (j+1),xStart+4,yStart+10); //draw alpha then number
							} else if (+width < 54 || +height < 54){ //tile size check
								ctx.font = "10px Helvetica";
								ctx.fillText(alphabet[i].toUpperCase() + (j+1),xStart+6,yStart+15); //draw alpha then number
							} else if (+width < 64 || +height < 64){ //tile size check
								ctx.font = "14px Helvetica";
								ctx.fillText(alphabet[i].toUpperCase() + (j+1),xStart+6,yStart+20); //draw alpha then number
							} else if (+width < 110 || +height < 110){ //tile size check
								ctx.font = "24px Helvetica";
								ctx.fillText(alphabet[i].toUpperCase() + (j+1),xStart+6,yStart+30); //draw alpha then number
							} else {
								ctx.font = "30px Helvetica";
								ctx.fillText(alphabet[i].toUpperCase() + (j+1),xStart+10,yStart+40); //draw alpha then number
							}//end size check
						} else {

						}

						//draw data flow (default for starting top left with horizontal rows.

						var arrow = downArr; //default direction
						if (dataFlow == 1) {
							if (oddOrEven == "odd") {
								arrow = rightArr;
							} else { arrow =leftArr;
							}
							if (i == 0 && oddOrEven =="odd"){ //left edge true + odd
								arrow = rightArr;
							} else if (i == 0 && oddOrEven =="even") { //left edge true + even
								arrow = downArr;
							} else if (i == columns-1 && oddOrEven =="odd") { //right edge true + odd
								arrow = downArr;
							} else if (i == columns-1 && oddOrEven =="even") { //right edge true + even
								arrow = leftArr;
							}
						}//end data flow check case 1
						else if (dataFlow == 2) {
							if (oddOrEven == "odd") {
								arrow = leftArr;
							} else { arrow =rightArr;
							}
							if (i == 0 && oddOrEven =="odd"){ //left edge true + odd
								arrow = downArr;
							} else if (i == 0 && oddOrEven =="even") { //left edge true + even
								arrow = rightArr;
							} else if (i == columns-1 && oddOrEven =="odd") { //right edge true + odd
								arrow = leftArr;
							} else if (i == columns-1 && oddOrEven =="even") { //right edge true + even
								arrow = downArr;
							}
						}//end data flow check case 2
						else if (dataFlow == 3) {
							if((rows % 2) != 1){//check if number of rows are even or odd
								if (oddOrEven == "odd") {
									arrow = leftArr;
								} else { arrow =rightArr;
								}
								if (i == 0 && oddOrEven =="odd"){ //left edge true + odd
									arrow = upArr;
								} else if (i == 0 && oddOrEven =="even") { //left edge true + even
									arrow = rightArr;
								} else if (i == columns-1 && oddOrEven =="odd") { //right edge true + odd
									arrow = leftArr;
								} else if (i == columns-1 && oddOrEven =="even") { //right edge true + even
									arrow = upArr;
								}
							}//end row even odd check
							else {
								if (oddOrEven == "odd") {
									arrow = rightArr;
								} else { arrow =leftArr;
								}
								if (i == 0 && oddOrEven =="odd"){ //left edge true + odd
									arrow = rightArr;
								} else if (i == 0 && oddOrEven =="even") { //left edge true + even
									arrow = upArr;
								} else if (i == columns-1 && oddOrEven =="odd") { //right edge true + odd
									arrow = upArr;
								} else if (i == columns-1 && oddOrEven =="even") { //right edge true + even
									arrow = leftArr;
								}
							}
						}//end data flow check case 3
						else if (dataFlow == 4) {
							if((rows % 2) != 1){//check if number of rows are even or odd
								if (oddOrEven == "odd") {
									arrow = rightArr;
								} else { arrow =leftArr;
								}
								if (i == 0 && oddOrEven =="odd"){ //left edge true + odd
									arrow = rightArr;
								} else if (i == 0 && oddOrEven =="even") { //left edge true + even
									arrow = upArr;
								} else if (i == columns-1 && oddOrEven =="odd") { //right edge true + odd
									arrow = upArr;
								} else if (i == columns-1 && oddOrEven =="even") { //right edge true + even
									arrow = leftArr;
								}
							}//end row even odd check
							else {
								if (oddOrEven == "odd") {
									arrow = leftArr;
								} else { arrow =rightArr;
								}
								if (i == 0 && oddOrEven =="odd"){ //left edge true + odd
									arrow = upArr;
								} else if (i == 0 && oddOrEven =="even") { //left edge true + even
									arrow = rightArr;
								} else if (i == columns-1 && oddOrEven =="odd") { //right edge true + odd
									arrow = leftArr;
								} else if (i == columns-1 && oddOrEven =="even") { //right edge true + even
									arrow = upArr;
								}
							}
						}//end data flow check case 4
						else if (dataFlow == 5) {
							if (colOddEven == "odd") {
								arrow = downArr;
							} else { arrow = upArr;
							}
							if (j == 0 && colOddEven == "odd") { //top edge true + odd
								arrow = downArr;
							} else if (j == 0 && colOddEven =="even") { //top edge true + even
								arrow = rightArr;
							} else if (j == rows-1 && colOddEven == "odd") { //bottom edge true + odd
								arrow = rightArr;
							} else if (j == rows-1 && colOddEven =="even") { //bottom edge true + even
								arrow = upArr;
							}
						}//end data flow check case 5
						else if (dataFlow == 6) {
							if((columns % 2) != 1){//check if number of rows are even or odd
								if (colOddEven == "odd") {
									arrow = upArr;
								} else { arrow = downArr;
								}
								if (j == 0 && colOddEven == "odd") { //top edge true + odd
									arrow = leftArr;
								} else if (j == 0 && colOddEven =="even") { //top edge true + even
									arrow = downArr;
								} else if (j == rows-1 && colOddEven == "odd") { //bottom edge true + odd
									arrow = upArr;
								} else if (j == rows-1 && colOddEven =="even") { //bottom edge true + even
									arrow = leftArr;
								}
							}//end even odd column check
							else {
								if (colOddEven == "odd") {
									arrow = downArr;
								} else { arrow = upArr;
								}
								if (j == 0 && colOddEven == "odd") { //top edge true + odd
									arrow = downArr;
								} else if (j == 0 && colOddEven =="even") { //top edge true + even
									arrow = leftArr;
								} else if (j == rows-1 && colOddEven == "odd") { //bottom edge true + odd
									arrow = leftArr;
								} else if (j == rows-1 && colOddEven =="even") { //bottom edge true + even
									arrow = upArr;
								}
							}
						}//end data flow check case 6
						else if (dataFlow == 7) {
							if (colOddEven == "odd") {
								arrow = upArr;
							} else { arrow = downArr;
							}
							if (j == 0 && colOddEven == "odd") { //top edge true + odd
								arrow = rightArr;
							} else if (j == 0 && colOddEven =="even") { //top edge true + even
								arrow = downArr;
							} else if (j == rows-1 && colOddEven == "odd") { //bottom edge true + odd
								arrow = upArr;
							} else if (j == rows-1 && colOddEven =="even") { //bottom edge true + even
								arrow = rightArr;
							}
						}//end data flow check case 7
						else if (dataFlow == 8) {
							if((columns % 2) != 1){//check if number of rows are even or odd
								if (colOddEven == "odd") {
									arrow = downArr;
								} else { arrow = upArr;
								}
								if (j == 0 && colOddEven == "odd") { //top edge true + odd
									arrow = downArr;
								} else if (j == 0 && colOddEven =="even") { //top edge true + even
									arrow = leftArr;
								} else if (j == rows-1 && colOddEven == "odd") { //bottom edge true + odd
									arrow = leftArr;
								} else if (j == rows-1 && colOddEven =="even") { //bottom edge true + even
									arrow = upArr;
								}
							}//end even odd column check
							else {
								if (colOddEven == "odd") {
									arrow = upArr;
								} else { arrow = downArr;
								}
								if (j == 0 && colOddEven == "odd") { //top edge true + odd
									arrow = leftArr;
								} else if (j == 0 && colOddEven =="even") { //top edge true + even
									arrow = downArr;
								} else if (j == rows-1 && colOddEven == "odd") { //bottom edge true + odd
									arrow = upArr;
								} else if (j == rows-1 && colOddEven =="even") { //bottom edge true + even
									arrow = leftArr;
								}
							}
						}//end data flow check case 8

						if (drawData){ //check drawData checkbox. no check = no data path
							ctx.fillStyle=datacolor;
							if (dataFlow == 1){ //check which data case and title being drawn to change first tile in data chain's arrow to green
								if (j== 0 && i == 0){
									ctx.fillStyle = dataStartColor;
								}

								if ((rows % 2) == 1 && j == rows-1 && i == columns-1){ //odd ammount of rows do this
									ctx.fillStyle = "#FF0000";
									arrow = stopSign;
								} else if ((rows % 2) != 1 && j == rows-1 && i ==0){ //even ammount do this
									ctx.fillStyle = "#FF0000";
									arrow = stopSign;
								}
							} else if (dataFlow == 2){
								if (j== 0 && i == columns-1){
									ctx.fillStyle = dataStartColor;
								}

								if ((rows % 2) == 1 && j == rows-1 && i == 0){ //odd ammount of rows do this
									ctx.fillStyle = "#FF0000";
									arrow = stopSign;
								} else if ((rows % 2) != 1 && j == rows-1 && i == columns-1){ //even ammount do this
									ctx.fillStyle = "#FF0000";
									arrow = stopSign;
								}
							} else if (dataFlow == 3){
								if (j== rows-1 && i == 0){
									ctx.fillStyle = dataStartColor;
								}
								if ((rows % 2) == 1 && j == 0 && i == columns-1){ //odd ammount of rows do this
									ctx.fillStyle = "#FF0000";
									arrow = stopSign;
								} else if ((rows % 2) != 1 && j == 0 && i == 0){ //even ammount do this
									ctx.fillStyle = "#FF0000";
									arrow = stopSign;
								}
							} else if (dataFlow == 4){
								if (j== rows-1 && i == columns-1){
									ctx.fillStyle = dataStartColor;
								}
								if ((rows % 2) == 1 && j == 0 && i == 0){ //odd ammount of rows do this
									ctx.fillStyle = "#FF0000";
									arrow = stopSign;
								} else if ((rows % 2) != 1 && j == 0 && i == columns-1){ //even ammount do this
									ctx.fillStyle = "#FF0000";
									arrow = stopSign;
								}
							} else if (dataFlow ==5){ //check which data case and title being drawn to change first tile in data chain's arrow to green
								if (j== 0 && i == 0){
									ctx.fillStyle = dataStartColor;
								}
								if ((columns % 2) == 1 && j == rows-1 && i == columns-1){ //odd ammount of columns do this
									ctx.fillStyle = "#FF0000";
									arrow = stopSign;
								} else if ((columns % 2) != 1 && j == 0 && i == columns-1){ //even ammount do this
									ctx.fillStyle = "#FF0000";
									arrow = stopSign;
								}
							} else if (dataFlow ==6){
								if (j== 0 && i == columns-1){
									ctx.fillStyle = dataStartColor;
								}
								if ((columns % 2) == 1 && j == rows-1 && i == 0){ //odd ammount of columns do this
									ctx.fillStyle = "#FF0000";
									arrow = stopSign;
								} else if ((columns % 2) != 1 && j == 0 && i == 0){ //even ammount do this
									ctx.fillStyle = "#FF0000";
									arrow = stopSign;
								}
							} else if (dataFlow ==7){
								if (j== rows-1 && i == 0){
									ctx.fillStyle = dataStartColor;
								}
								if ((columns % 2) == 1 && j == 0 && i == columns-1){ //odd ammount of columns do this
									ctx.fillStyle = "#FF0000";
									arrow = stopSign;
								} else if ((columns % 2) != 1 && j == rows-1 && i == columns-1){ //even ammount do this
									ctx.fillStyle = "#FF0000";
									arrow = stopSign;
								}
							} else if (dataFlow ==8){
								if (j== rows-1 && i == columns-1){
									ctx.fillStyle = dataStartColor;
								}
								if ((columns % 2) == 1 && j == 0 && i == 0){ //odd ammount of columns do this
									ctx.fillStyle = "#FF0000";
									arrow = stopSign;
								} else if ((columns % 2) != 1 && j == rows-1 && i == 0){ //even ammount do this
									ctx.fillStyle = "#FF0000";
									arrow = stopSign;
								}
							} else {
								ctx.fillStyle=datacolor;
							}
							if (+width < 35 || +height < 35){ //tile size check
								ctx.font = "8px Helvetica";
								ctx.fillText(arrow,xStart+20,yStart+10); //small
							} else if (+width < 54 || +height < 54){ //tile size check
								ctx.font = "10px Helvetica";
								ctx.fillText(arrow,xStart+25,yStart+15); //med
							} else if (+width < 64 || +height < 64){ //tile size check
								ctx.font = "14px Helvetica";
								ctx.fillText(arrow,xStart+30,yStart+20); //med
							} else if (+width < 110 || +height < 110){ //tile size check
								ctx.font = "24px Helvetica";
								ctx.fillText(arrow,xStart+40,yStart+30); //med
							} else {
								ctx.font = "30px Helvetica";
								ctx.fillText(arrow,xStart+80,yStart+40); //large
							}//end size check
						} else {
						}
						if (drawInfo) { //draw info tile if checkbox checkes
							function numberWithCommas(x) {
							    return x.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
							}

							tileCount = (+columns * +rows);
							var hRes = (+width * +columns);
							var vRes = (+height * +rows);
							var tPix = (hRes*vRes);
							var topMarg = vRes - 10;
							var leftMarg = 10;

							//var info = +tileCount+" tiles. "+hRes+" x "+vRes+" ("+numberWithCommas(tPix)+") pixels";
							var info = +hRes+" x "+vRes+" ("+numberWithCommas(tPix)+") pixels";
							ctx.fillStyle="#000000";
							ctx.font = "12px Lucida Console";

							ctx.fillText(info,leftMarg, topMarg);
						}
						if (drawBorder){

							ctx.lineWidth=borderW*2;
							ctx.strokeStyle=bordercolor;
							ctx.strokeRect(xStart,yStart,width,height); //draw single tile
							//console.log("Tile Drawn : ",alphabet[i],+j+1);
							//ctx.strokeRect(0,0,(+rwidth),(+rheight)); //Raster border
							//ctx.strokeRect(0,0,(+width * +columns),(+height * +rows)); //draw single tile
							//added next 3 lines
						}

						if (drawRBorder){
						ctx.lineWidth=borderR*2;
							ctx.strokeStyle="#000000";
							ctx.strokeRect(0,0,(+rwidth),(+rheight));
						}
				//		if (drawBorderR){

					//		ctx.lineWidth=borderR*2;
						//	ctx.strokeStyle=borderRcolor;
							//ctx.strokeRect(0,0,(+rwidth),(+rheight));
							//ctx.strokeRect(0,0,(+width * +columns),(+height * +rows)); //draw single tile

				//		}
						xStart = +xStart + +width; //shift starting coords for next column
													 //"+"prefix on vars to convert from string back to int
					}//end columns for

					xStart = 0;  //reset x coord to 0 (default) for begining of next row
					yStart = +yStart + +height;  //shift starting coords for next row
												 //"+"prefix on vars to convert from string back to int
				}//end rows for
			tileCount = (+columns * +rows);

			console.log("RW : " + rwidth);
		  console.log("RH : " + rheight);

				console.log("W : " + width);
		    console.log("H : " + height);
		    console.log("Columns : " + columns);
		    console.log("Rows : " + rows);
		    console.log("Border Width : " + borderW);
				   console.log("Raster Width : " + borderR);
		    console.log("Tile Count : " + tileCount);
		    console.log("x : " + xStart);
		    console.log("y : " + yStart);
			console.log("C1 : " + color1);
		    console.log("C2 : " + color2);
		    console.log("Dataflow : " + dataFlow);
		    console.log("drawCoords : " + drawCoords);
		    console.log("drawData : " + drawData);

		    } //end of draw();

		     // create Array whos dimensions are equal to rows and columns vars.
			function createArray(){
				var wallArray = new Array(columns);
				for (var i = 0; i < columns; i++) {
				  wallArray[i] = new Array(rows);
				}
		    //document.getElementById("arraylength").innerHTML = wallArray.length;
		    }//end of createArray

		    /* REGISTER DOWNLOAD HANDLER */
			/* Only convert the canvas to Data URL when the user clicks.
		 This saves RAM and CPU ressources in case this feature is not required. */
				function dlCanvas() {
				  var dt = canvas.toDataURL('image/png');
				  /* Change MIME type to trick the browser to downlaod the file instead of displaying it */
//  				  dt = dt.replace(/^data:image\/[^;]*/, 'data:application/octet-stream/');

				  /* In addition to <a>'s "download" attribute, you can define HTTP-style headers */
// 				  dt = dt.replace(/^data:application\/octet-stream/, 'data:application/octet-stream;headers=Content-Disposition%3A%20attachment%3B%20filename=Canvas.png');

				  this.href = dt;
				};
				document.getElementById("dl").addEventListener('click', dlCanvas, false);



		}); // end $(function(){});
		$( document ).ready(function() {

		     $("a#toggle").click(function()
		                         {
		                            $("#features").slideToggle();
		                            return false;
		                         });
		  });
